#include <windows.h>

const char WindowsClassName[] = "View";

#define FILE_Menu 1001
#define OPTIONS_Menu 2001

void Draw_to_screen(HWND hwnd);
bool test1 = false;

//Global variables for draw to screen
HDC hdc;
HDC hdcMem;
HBITMAP bitmap;

// Step 4: the Window Procedure
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
		//----starting application initializations--[start]--------
        case WM_CREATE:
        {
            HMENU hMenu, hSubMenu;

            hMenu = CreateMenu();

            hSubMenu = CreatePopupMenu();
            AppendMenu(hSubMenu, MF_STRING, FILE_Menu, "E&xit");
            AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&File");

            hSubMenu = CreatePopupMenu();
            AppendMenu(hSubMenu, MF_STRING, OPTIONS_Menu, "&Options");
            AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&Options");

            SetMenu(hwnd, hMenu);

        }
        break;
		//----starting application initializations--[end]-----------

		//----Menu options--------------------------[start]---------
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case FILE_Menu:
					{
						PostMessage(hwnd, WM_CLOSE, 0, 0);
					}

                break;

                case OPTIONS_Menu:
					{
						test1 = true;
						
					}

                break;
            }
        break;
		//----Menu options--------------------------[end]-------------

	    case WM_PAINT:
		{
			//Begin Paint/ End Paint only applicable inside this WM_PAINT
	        PAINTSTRUCT ps;

	        HDC hdc = BeginPaint(hwnd, &ps);
		
			DeleteDC(hdc);

	        EndPaint(hwnd, &ps);
	    }
	    break;

        case WM_CLOSE:
            DestroyWindow(hwnd);
        break;

        case WM_DESTROY:
            PostQuitMessage(0);
        break;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASSEX wc;
    HWND hwnd;
    MSG Msg;

    //Step 1: Registering the Window Class
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = WindowsClassName;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    if(!RegisterClassEx(&wc))
    {
        MessageBox(NULL, "Window Registration Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    // Step 2: Creating the Window
    hwnd = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        WindowsClassName,
        "view",
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, 300, 300,
        NULL, NULL, hInstance, NULL);

    if(hwnd == NULL)
    {
        MessageBox(NULL, "Window Creation Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

	//------Setting up the back buffering for paint [start]--------
	hdc = GetDC(hwnd); 
	hdcMem = CreateCompatibleDC(hdc); 
	// always create the bitmap for the memdc from the window dc
	/* Create an appropriately sized device-dependent bitmap or DIB section bitmap
	that will serve as the "memory" of the memory device context.
	You can use the CreateCompatibleBitmap function to create a device-dependent bitmap
	or the CreateDIBSection function to create a DIB section bitmap.
	
		HBITMAP CreateDIBSection(
		  __in   HDC hdc,
		  __in   const BITMAPINFO *pbmi, -A pointer to a BITMAPINFO structure that specifies various attributes of the DIB, including the bitmap dimensions and colors.
		  __in   UINT iUsage, -options: DIB_PAL_COLORS / DIB_RGB_COLORS
		  __out  VOID **ppvBits, -A pointer to a variable that receives a pointer to the location of the DIB bit values.
		  __in   HANDLE hSection, -A handle to a file-mapping object that the function will use to create the DIB. This parameter can be NULL.
		  __in   DWORD dwOffset -The offset from the beginning of the file-mapping object referenced by hSection where storage for the bitmap bit values is to begin. This value is ignored if hSection is NULL.
		);

		-If the function succeeds, the return value is a handle to the newly created DIB, and *ppvBits points to the bitmap bit values.

		-If the function fails, the return value is NULL, and *ppvBits is NULL.
	*/
	//bitmap = CreateCompatibleBitmap(hdc,300,300);
	// BITMAPINFO structure describing the dimensions and colors of the bitmap, and an array of bytes defining the pixels of the bitmap. 
	
	BITMAPINFO Bitmap_info;
	unsigned int pImageData; //Pointer to address of image data

	Bitmap_info.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	Bitmap_info.bmiHeader.biWidth = 300;
	Bitmap_info.bmiHeader.biHeight = -300;
	Bitmap_info.bmiHeader.biPlanes = 1;
	Bitmap_info.bmiHeader.biBitCount = 32;
	Bitmap_info.bmiHeader.biCompression = BI_RGB; 
	Bitmap_info.bmiHeader.biSizeImage = 0;
	Bitmap_info.bmiHeader.biXPelsPerMeter = 0;
	Bitmap_info.bmiHeader.biYPelsPerMeter = 0;
	Bitmap_info.bmiHeader.biClrUsed = 0;
	Bitmap_info.bmiHeader.biClrImportant = 0;

	bitmap = CreateDIBSection(hdc, &Bitmap_info, DIB_RGB_COLORS, (void **) &pImageData, NULL, 0);
	SelectObject(hdcMem, bitmap);


	// only execute the code up to this point one time
	// that is, you only need to create the back buffer once
	// you can reuse it over and over again after that

	//------Setting up the back buffering for paint [end]-----------

	unsigned int timer = 0;
	// message loop
	while(TRUE)
	{
	    // Check to see if any messages are waiting in the queue
	    while(PeekMessage(&Msg, NULL, 0, 0, PM_REMOVE))
	    {
	        // Translate the message and dispatch it to WindowProc()
	        TranslateMessage(&Msg);
	        DispatchMessage(&Msg);
	    }

	    // If the message is WM_QUIT, exit the while loop
	    if(Msg.message == WM_QUIT)
	        break;

		
		if (GetTickCount() - timer >= 500)
		{
			timer = GetTickCount();
			Draw_to_screen(hwnd);
		}
	}

	//------Removing the back buffering for paint [start]--------
	
	// Clean up - only need to do this one time as well
	DeleteDC(hdcMem);
	DeleteObject(bitmap);
	ReleaseDC(hwnd, hdc);
	
	//------Removing the back buffering for paint [end]----------
    return Msg.wParam;
}

void Draw_to_screen(HWND hwnd)
{
	RECT rect = {0,0, 300, 300};
	FillRect(hdcMem, &rect, (HBRUSH)(WHITE_BRUSH));
	
	SetTextColor(hdcMem, RGB(255,0,255));
	TextOut(hdcMem, 0, 0, "TEST", 4);
	
	// draw on hdcMem
	// for example  ...

	Rectangle(hdcMem, 50, 50, 100, 100);

	// when finished drawing blit the hdcMem to the hdc
	BitBlt(hdc, 0, 0, 300, 300, hdcMem, 0, 0, SRCCOPY);
}

/* Notes on Double Buffering

-----BITMAPINFO [pointer*]----
typedef struct tagBITMAPINFO {
  BITMAPINFOHEADER bmiHeader; //secondary STRUCT
  RGBQUAD          bmiColors[1];
} BITMAPINFO, *PBITMAPINFO;

-----BITMAPINFOHEADER [pointer*]----
typedef struct tagBITMAPINFOHEADER {
  DWORD biSize; -The number of bytes required by the structure.
  LONG  biWidth; -image width
  LONG  biHeight; -The height of the bitmap, in pixels. If biHeight is positive, the bitmap is a bottom-up DIB and its origin is the lower-left corner. If biHeight is negative, the bitmap is a top-down DIB and its origin is the upper-left corner.
  WORD  biPlanes; -The number of planes for the target device. This value must be set to 1.
  WORD  biBitCount; -8/16/24/32
  DWORD biCompression; -The type of compression for a compressed bottom-up bitmap (top-down DIBs cannot be compressed). 
  DWORD biSizeImage; -The size, in bytes, of the image. This may be set to zero for BI_RGB bitmaps.
  LONG  biXPelsPerMeter; -The horizontal resolution, in pixels-per-meter, of the target device for the bitmap.
  LONG  biYPelsPerMeter; -The vertical resolution, in pixels-per-meter, of the target device for the bitmap.
  DWORD biClrUsed; -The number of color indexes in the color table that are actually used by the bitmap.
  DWORD biClrImportant; -The number of color indexes that are required for displaying the bitmap. If this value is zero, all colors are required.
} BITMAPINFOHEADER, *PBITMAPINFOHEADER;
*/