#include <windows.h>
#include <stdio.h>

const char WindowsClassName[] = "view";

#define FILE_Menu 1001
#define OPTIONS_Menu 2001

void Draw_to_screen(HWND hwnd);
bool test1 = false;

//Global variables for draw to screen
HDC hdc;
HDC hdcMem;
HBITMAP bitmap;

unsigned char *pImageData; //Pointer to address of image data

BITMAPFILEHEADER Bitmap_fileheader;
// BITMAPINFO structure describing the dimensions and colors of the bitmap, and an array of bytes defining the pixels of the bitmap. 
BITMAPINFO Bitmap_info; //44byte

// Step 4: the Window Procedure
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
		//----starting application initializations--[start]--------
        case WM_CREATE:
        {
            HMENU hMenu, hSubMenu;

            hMenu = CreateMenu();

            hSubMenu = CreatePopupMenu();
            AppendMenu(hSubMenu, MF_STRING, FILE_Menu, "E&xit");
            AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&File");

            hSubMenu = CreatePopupMenu();
            AppendMenu(hSubMenu, MF_STRING, OPTIONS_Menu, "&Options");
            AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&Options");

            SetMenu(hwnd, hMenu);

        }
        break;
		//----starting application initializations--[end]-----------

		//----Menu options--------------------------[start]---------
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case FILE_Menu:
					{
						PostMessage(hwnd, WM_CLOSE, 0, 0);
					}

                break;

                case OPTIONS_Menu:
					{
						test1 = true;

						OPENFILENAME openfilename;
						char FileName[MAX_PATH] = "";

						ZeroMemory(&openfilename, sizeof(openfilename));

						openfilename.lStructSize = sizeof(openfilename); // SEE NOTE BELOW
						openfilename.hwndOwner = hwnd;
						openfilename.lpstrFilter = "Bitmap Files (*.bmp)\0*.*\0All Files (*.bmp)\0*.bmp\0";
						openfilename.lpstrFile = FileName;
						openfilename.nMaxFile = MAX_PATH;
						openfilename.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
						openfilename.lpstrDefExt = "bmp";

						if(GetOpenFileName(&openfilename)) //create file only if true
						{
							FILE *file;
							file = fopen(FileName, "wb");
							fwrite(&Bitmap_fileheader, 1, sizeof(BITMAPFILEHEADER), file); //14 bytes
							fwrite(&Bitmap_info, 1, sizeof(BITMAPINFOHEADER), file); //44 - 4 = 40 bytes BITMAPINFOHEADER not BITMAPINFO which contains both
							fwrite(pImageData, 1, 300*300*4, file);
							fclose(file);
						}
					}

                break;
            }
        break;
		//----Menu options--------------------------[end]-------------

	    case WM_PAINT:
		{
			//Begin Paint/ End Paint only applicable inside this WM_PAINT
	        PAINTSTRUCT ps;

	        HDC hdc = BeginPaint(hwnd, &ps);
		
			DeleteDC(hdc);

	        EndPaint(hwnd, &ps);
	    }
	    break;

        case WM_CLOSE:
            DestroyWindow(hwnd);
        break;

        case WM_DESTROY:
            PostQuitMessage(0);
        break;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASSEX wc;
    HWND hwnd;
    MSG Msg;

    //Step 1: Registering the Window Class
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = WindowsClassName;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    if(!RegisterClassEx(&wc))
    {
        MessageBox(NULL, "Window Registration Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    // Step 2: Creating the Window
    hwnd = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        WindowsClassName,
        "view",
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, 300, 300,
        NULL, NULL, hInstance, NULL);

    if(hwnd == NULL)
    {
        MessageBox(NULL, "Window Creation Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

	//------Setting up the back buffering for paint [start]--------
	hdc = GetDC(hwnd); 
	hdcMem = CreateCompatibleDC(hdc); 

	//BITMAPINFO
	Bitmap_info.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	Bitmap_info.bmiHeader.biWidth = 300;
	Bitmap_info.bmiHeader.biHeight = -300;
	Bitmap_info.bmiHeader.biPlanes = 1;
	Bitmap_info.bmiHeader.biBitCount = 32;
	Bitmap_info.bmiHeader.biCompression = BI_RGB; 
	Bitmap_info.bmiHeader.biSizeImage = 300 * 300 *4; //width * height *32 bit
	Bitmap_info.bmiHeader.biXPelsPerMeter = 0;
	Bitmap_info.bmiHeader.biYPelsPerMeter = 0;
	Bitmap_info.bmiHeader.biClrUsed = 0;
	Bitmap_info.bmiHeader.biClrImportant = 0;

	//BITMAPFILEHEADER
	Bitmap_fileheader.bfType = 0x4D42; //"BM"
	Bitmap_fileheader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)+Bitmap_info.bmiHeader.biSizeImage;
	Bitmap_fileheader.bfReserved1 	= 0;
	Bitmap_fileheader.bfReserved2 	= 0;
	Bitmap_fileheader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	bitmap = CreateDIBSection(hdc, &Bitmap_info, DIB_RGB_COLORS, (void **) &pImageData, NULL, 0);
	SelectObject(hdcMem, bitmap);

	//------Setting up the back buffering for paint [end]-----------

	unsigned int timer = 0;
	// message loop
	while(TRUE)
	{
	    // Check to see if any messages are waiting in the queue
	    while(PeekMessage(&Msg, NULL, 0, 0, PM_REMOVE))
	    {
	        // Translate the message and dispatch it to WindowProc()
	        TranslateMessage(&Msg);
	        DispatchMessage(&Msg);
	    }

	    // If the message is WM_QUIT, exit the while loop
	    if(Msg.message == WM_QUIT)
	        break;

		
		if (GetTickCount() - timer >= 500)
		{
			timer = GetTickCount();
			Draw_to_screen(hwnd);
		}
	}

	//------Removing the back buffering for paint [start]--------
	
	// Clean up - only need to do this one time as well
	DeleteDC(hdcMem);
	DeleteObject(bitmap);
	ReleaseDC(hwnd, hdc);
	
	//------Removing the back buffering for paint [end]----------
    return Msg.wParam;
}

void Draw_to_screen(HWND hwnd)
{
	RECT rect = {0,0, 300, 300};
	FillRect(hdcMem, &rect, (HBRUSH)(WHITE_BRUSH));
	
	SetTextColor(hdcMem, RGB(255,0,255));
	TextOut(hdcMem, 0, 0, "TEST", 4);
	SetPixel(hdcMem, 0, 0, RGB(10, 253, 100));
	SetPixel(hdcMem, 1, 0, RGB(10, 255, 100));
	SetPixel(hdcMem, 102, 10, RGB(0, 255, 0));
	SetPixel(hdcMem, 103, 10, RGB(0, 255, 0));

	Rectangle(hdcMem, 50, 50, 100, 100);

	//modifying raw image data array[]
	/*
	pImageData[0] = 255; 
	pImageData[1] = 0;   
	pImageData[2] = 255; 
	pImageData[3] = 0;   
	*/

	// when finished drawing blit the hdcMem to the hdc
	BitBlt(hdc, 0, 0, 300, 300, hdcMem, 0, 0, SRCCOPY);
}

/* Notes


*/