#include <windows.h>
#include <stdio.h>

const char WindowsClassName[] = "view";

#define FILE_Exit 1001
#define FILE_Save 1002
#define FILE_Load 1003
#define OPTIONS_Menu 2001

void Draw_to_screen(HWND hwnd);
bool test1 = false;

//Global variables for draw to screen
HDC hdc;
HDC hdcMem;
HBITMAP bitmap;

int width = 300;
int height = 300;
int BitCount = 32;

unsigned char *pImageData; //Pointer to address of image data

BITMAPFILEHEADER Bitmap_fileheader;
// BITMAPINFO structure describing the dimensions and colors of the bitmap, and an array of bytes defining the pixels of the bitmap. 
BITMAPINFO Bitmap_info; //44byte

// Step 4: the Window Procedure
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
		//----starting application initializations--[start]--------
        case WM_CREATE:
        {
            HMENU hMenu, hSubMenu;

            hMenu = CreateMenu();

            hSubMenu = CreatePopupMenu();
			AppendMenu(hSubMenu, MF_STRING, FILE_Load, "&Load");
            AppendMenu(hSubMenu, MF_STRING, FILE_Save, "&Save");
			AppendMenu(hSubMenu, MF_STRING, FILE_Exit, "E&xit");
            AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&File");

            hSubMenu = CreatePopupMenu();
            AppendMenu(hSubMenu, MF_STRING, OPTIONS_Menu, "&Options");
            AppendMenu(hMenu, MF_STRING | MF_POPUP, (UINT)hSubMenu, "&Options");

            SetMenu(hwnd, hMenu);

        }
        break;
		//----starting application initializations--[end]-----------

		//----Menu options--------------------------[start]---------
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case FILE_Exit:
					{
						PostMessage(hwnd, WM_CLOSE, 0, 0);
					}

                break;

                case OPTIONS_Menu:
					{

					}

                break;

                case FILE_Load:
					{
						OPENFILENAME openfilename;
						char FileName[MAX_PATH] = "";

						ZeroMemory(&openfilename, sizeof(openfilename));

						openfilename.lStructSize = sizeof(openfilename); // SEE NOTE BELOW
						openfilename.hwndOwner = hwnd;
						openfilename.lpstrFilter = "Bitmap Files (*.bmp)\0*.*\0Bitmap Files 24bit (*.bmp)\0*.bmp\0";
						openfilename.lpstrFile = FileName;
						openfilename.nMaxFile = MAX_PATH;
						openfilename.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
						openfilename.lpstrDefExt = "bmp";

						if(GetOpenFileName(&openfilename)) //create file only if true
						{
							FILE *file;
							file = fopen(FileName, "rb");
							fread(&Bitmap_fileheader, 1, sizeof(BITMAPFILEHEADER), file); //14 bytes
							fread(&Bitmap_info, 1, sizeof(BITMAPINFOHEADER), file); //44 - 4 = 40 bytes BITMAPINFOHEADER not BITMAPINFO which contains both
							
							width =	Bitmap_info.bmiHeader.biWidth;
							height = Bitmap_info.bmiHeader.biHeight;
							if (height < 0) height = height *-1;

							//loading 32bit bitmaps
							if(Bitmap_info.bmiHeader.biBitCount == 32)
							{
								fread(pImageData, 1, width*(Bitmap_info.bmiHeader.biHeight*-1)*4, file);
							}

							//loading 24bit bitmaps
							if(Bitmap_info.bmiHeader.biBitCount == 24)
							{
								//bool padding = false;
								//if (width > 0) padding = true;
								int extra_padding = width%4;
								unsigned char *converter_image_buffer;
								converter_image_buffer = (unsigned char*) malloc (width * height * 3 + height * extra_padding);
								ZeroMemory(converter_image_buffer, sizeof(converter_image_buffer));
								fread(converter_image_buffer, 1, width*height*3+height*extra_padding, file);

								//convert data 24bit to 32 bitmap
								//images are stored reserse order, row by row
								for (int y = 0; y < height; y++)
								{
	
									for (int x = 0; x < width; x++)
									{
										pImageData[(height-y-1)*width*4+(x*4)] = converter_image_buffer[(y*width*3+y*extra_padding)+(x*3)];
										pImageData[(height-y-1)*width*4+(x*4)+1] = converter_image_buffer[(y*width*3+y*extra_padding)+(x*3)+1];
										pImageData[(height-y-1)*width*4+(x*4)+2] = converter_image_buffer[(y*width*3+y*extra_padding)+(x*3)+2];
									}
								}
								//BITMAPINFO
								Bitmap_info.bmiHeader.biHeight = -height;
								Bitmap_info.bmiHeader.biBitCount = 32;
								Bitmap_info.bmiHeader.biSizeImage = width * height * (BitCount/8); //width * height *32 bit


								//BITMAPFILEHEADER
								Bitmap_fileheader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)+Bitmap_info.bmiHeader.biSizeImage;
								Bitmap_fileheader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

								free (converter_image_buffer);
							}
							
							
							fclose(file);
						}
					}

                break;

                case FILE_Save:
					{
						OPENFILENAME openfilename;
						char FileName[MAX_PATH] = "";

						ZeroMemory(&openfilename, sizeof(openfilename));

						openfilename.lStructSize = sizeof(openfilename); // SEE NOTE BELOW
						openfilename.hwndOwner = hwnd;
						openfilename.lpstrFilter = "Bitmap Files (*.bmp)\0*.*\0Bitmap Files 24bit (*.bmp)\0*.bmp\0";
						openfilename.lpstrFile = FileName;
						openfilename.nMaxFile = MAX_PATH;
						openfilename.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
						openfilename.lpstrDefExt = "bmp";

						if(GetOpenFileName(&openfilename)) //create file only if true
						{
							if(openfilename.nFilterIndex == 1)
							{
								FILE *file;
								file = fopen(FileName, "wb");
								fwrite(&Bitmap_fileheader, 1, sizeof(BITMAPFILEHEADER), file); //14 bytes
								fwrite(&Bitmap_info, 1, sizeof(BITMAPINFOHEADER), file); //44 - 4 = 40 bytes BITMAPINFOHEADER not BITMAPINFO which contains both
								fwrite(pImageData, 1, Bitmap_info.bmiHeader.biWidth*height*4, file);
								fclose(file);
							}

							if(openfilename.nFilterIndex == 2)
							{
								//bool padding = false;
								//if (width%4 > 0) padding = true;
								int extra_padding = width%4;
								unsigned char *converter_image_buffer;
								converter_image_buffer = (unsigned char*) malloc (width * height * 3 + height * extra_padding);
								ZeroMemory(converter_image_buffer, sizeof(converter_image_buffer));
								
								//convert data 32bit to 24 bitmap
								//images are stored reserse order, row by row
								for (int y = 0; y < height; y++)
								{
	
									for (int x = 0; x < width; x++)
									{
										converter_image_buffer[(y*width*3+y*extra_padding)+(x*3)] = pImageData[(height-y-1)*width*4+(x*4)];
										converter_image_buffer[(y*width*3+y*extra_padding)+(x*3)+1] = pImageData[(height-y-1)*width*4+(x*4)+1];
										converter_image_buffer[(y*width*3+y*extra_padding)+(x*3)+2] = pImageData[(height-y-1)*width*4+(x*4)+2];
									}
								}

								//BITMAPINFO
								Bitmap_info.bmiHeader.biHeight = height;
								Bitmap_info.bmiHeader.biBitCount = 24;
								Bitmap_info.bmiHeader.biSizeImage = width * height * (BitCount/8); //width * height *32 bit


								//BITMAPFILEHEADER
								Bitmap_fileheader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)+Bitmap_info.bmiHeader.biSizeImage;
								Bitmap_fileheader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);


								FILE *file;
								file = fopen(FileName, "wb");
								fwrite(&Bitmap_fileheader, 1, sizeof(BITMAPFILEHEADER), file); //14 bytes
								fwrite(&Bitmap_info, 1, sizeof(BITMAPINFOHEADER), file); //44 - 4 = 40 bytes BITMAPINFOHEADER not BITMAPINFO which contains both
								fwrite(converter_image_buffer, 1, width*height*3+height*extra_padding, file);
								fclose(file);
								free (converter_image_buffer);
							}
						}
					}

                break;
            }
        break;
		//----Menu options--------------------------[end]-------------

	    case WM_PAINT:
		{
			//Begin Paint/ End Paint only applicable inside this WM_PAINT
	        PAINTSTRUCT ps;

	        HDC hdc = BeginPaint(hwnd, &ps);
		
			DeleteDC(hdc);

	        EndPaint(hwnd, &ps);
	    }
	    break;

        case WM_CLOSE:
            DestroyWindow(hwnd);
        break;

        case WM_DESTROY:
            PostQuitMessage(0);
        break;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASSEX wc;
    HWND hwnd;
    MSG Msg;

    //Step 1: Registering the Window Class
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = WindowsClassName;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    if(!RegisterClassEx(&wc))
    {
        MessageBox(NULL, "Window Registration Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    // Step 2: Creating the Window
    hwnd = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        WindowsClassName,
        "view",
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, 300, 300,
        NULL, NULL, hInstance, NULL);

    if(hwnd == NULL)
    {
        MessageBox(NULL, "Window Creation Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

	//------Setting up the back buffering for paint [start]--------
	hdc = GetDC(hwnd); 
	hdcMem = CreateCompatibleDC(hdc); 

	//BITMAPINFO
	Bitmap_info.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	Bitmap_info.bmiHeader.biWidth = width;
	Bitmap_info.bmiHeader.biHeight = -height;
	Bitmap_info.bmiHeader.biPlanes = 1;
	Bitmap_info.bmiHeader.biBitCount = BitCount;
	Bitmap_info.bmiHeader.biCompression = BI_RGB; 
	Bitmap_info.bmiHeader.biSizeImage = width * height * (BitCount/8); //width * height *32 bit
	Bitmap_info.bmiHeader.biXPelsPerMeter = 0;
	Bitmap_info.bmiHeader.biYPelsPerMeter = 0;
	Bitmap_info.bmiHeader.biClrUsed = 0;
	Bitmap_info.bmiHeader.biClrImportant = 0;

	//BITMAPFILEHEADER
	Bitmap_fileheader.bfType = 0x4D42; //"BM"
	Bitmap_fileheader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)+Bitmap_info.bmiHeader.biSizeImage; //Entire file size
	Bitmap_fileheader.bfReserved1 	= 0;
	Bitmap_fileheader.bfReserved2 	= 0;
	Bitmap_fileheader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER); //start of raw image data coordinate

	bitmap = CreateDIBSection(hdc, &Bitmap_info, DIB_RGB_COLORS, (void **) &pImageData, NULL, 0);
	SelectObject(hdcMem, bitmap);

	//------Setting up the back buffering for paint [end]-----------

	unsigned int timer = 0;
	// message loop
	while(TRUE)
	{
	    // Check to see if any messages are waiting in the queue
	    while(PeekMessage(&Msg, NULL, 0, 0, PM_REMOVE))
	    {
	        // Translate the message and dispatch it to WindowProc()
	        TranslateMessage(&Msg);
	        DispatchMessage(&Msg);
	    }

	    // If the message is WM_QUIT, exit the while loop
	    if(Msg.message == WM_QUIT)
	        break;

		
		if (GetTickCount() - timer >= 500)
		{
			timer = GetTickCount();
			Draw_to_screen(hwnd);
		}
	}

	//------Removing the back buffering for paint [start]--------
	
	// Clean up - only need to do this one time as well
	DeleteDC(hdcMem);
	DeleteObject(bitmap);
	ReleaseDC(hwnd, hdc);
	
	//------Removing the back buffering for paint [end]----------
    return Msg.wParam;
}

void Draw_to_screen(HWND hwnd)
{

	// when finished drawing blit the hdcMem to the hdc
	BitBlt(hdc, 0, 0, width, height, hdcMem, 0, 0, SRCCOPY);
}

/* Notes
-loading 24bits
-image canvas incorrect size
*/